/***********************************************************************************
 * @Copyright (c)	:(C)2013, Qindao ieslab Co., Ltd
 * @FileName   	      :new_gsm_EEPROM_processor.c
 * @Author       	:Intelligent gas team
 * @Version      	:V1.0
 * @Date         	:2013-11-29
 * @Description	:the function of the entity of system processor
 ************************************************************************************/
#ifdef __cplusplus
extern "C"
{
#endif
/*--------------------------------Including-------------------------------------------*/
#include "UWater_sys.h"
#include "UWater_frame_app.h"
#include "UWater_eeprom_driver.h"
#include "UWater_encryption_driver.h"
#include "UWater_valve_driver.h"
#include "UWater_uart_driver.h"
#include "UWater_timer1uS_driver.h"
#include "UWater_valve_app.h"
#include "UWater_rtcc_app.h"
#include "UWater_gp22_app.h"
#include "SOE.h"
#include "nb_upload_monitor.h"
#include "eeprom_app.h"
/*------------------------------ Variable Define -------------------------------------*/

//static u8 ee_package_rd_num;		//
//static u8 ee_package_wr_num;		//д
//static u8 ee_package_erase_num;		//
static IMPORTANT_DATA_OP important_data_rd_state = IMPORTANT_DATA_OP_S0; 
//static IMPORTANT_DATA_OP important_data_wr_state = IMPORTANT_DATA_OP_S0;
//static IMPORTANT_DATA_OP important_data_erase_state = IMPORTANT_DATA_OP_S0;
static u8 important_data_rd_msg;
static TYPE_EE_INIT_STATE tmp_init_stat = EE_INIT_STATE_S0;//ʼ״̬ 
static u8 task_init_complete = FALSE;//ʼɱ־
static u32 frame_para_buf[FRAME_PARA_BUF_LEN];//ϵͳ

Data_object Sys_data_object;//ϵͳ
DateTime rtcc_tmp_ee_app;


static void SysData_Init(void);//ϵͳʼ
static void Coefficient_Init(void); //ʽʼ
static void Flow_coef_Init(void);//ϵʼ
static void UDP_Update_Init(void);//UDP ipʼ
static void SOE_Pint_Init(void);
static void RtccInitApp(void);

//ҪдıַeeַҪSys_data_objectṹ
u16 ee_addr_compute(u8 *data_addr)
{
    u16 addr_result;
    if(data_addr >= (u8*)(&Sys_data_object.P1))
    {
        if( data_addr < ((u8*)(&Sys_data_object.P1) + sizeof(Sys_data_object.P1)) )
        {
            addr_result = EEP_FRAME_BASE_ADDR + data_addr - (u8*)(&Sys_data_object.P1);
            return addr_result;	
        }
        else
        {
            return 0;
        }
    }
    else
    {
        return 0;
    }
}

//״ϵʼֱ
void FirstPowerOnInit(void)
{
  	//Sys_data_object.P1.first_power_flg = FRAME_FIRST_POWER_FLG;//u8 first_power_flg---һϵ־,
	Sys_data_object.P1.start_using_flg = 0x00; //0x00,//u8 start_using_flg---ñ־Ĭϲ
	/*ϱƵu8 report_freq_val[5]*/
	Sys_data_object.P1.Time_upload_2006.s.type   = 0x02; //0x02,//report_freq_val[0]---ģʽ
	Sys_data_object.P1.Time_upload_2006.s.period = 0x00; //0x00,//report_freq_val[1]---ģʽЧ
	Sys_data_object.P1.Time_upload_2006.s.hour   = 0x06; //0x06,//report_freq_val[2]---6
	Sys_data_object.P1.Time_upload_2006.s.minute = 0x00; //0x00,//report_freq_val[3]---0
	Sys_data_object.P1.Time_upload_2006.s.second = 0x00; //0x00,//report_freq_val[4]---0
    /*ipַ:117.60.157.137*/
	Sys_data_object.P1.server_ip[0] =221;//117; //117,//server_ip[0]
	Sys_data_object.P1.server_ip[1] = 229;//60;  //60,//server_ip[1]
	Sys_data_object.P1.server_ip[2] =214;//157;  //157,//server_ip[2]
	Sys_data_object.P1.server_ip[3] =202;//137;  //137,//server_ip[3]
	/*˿ں:5683=0x1633*/
	Sys_data_object.P1.server_port.datas = 5683; 
	//0x33,//server_port.datas_map.data0
	//0x16,//server_port.datas_map.data1      
	/*ϱʼʱ:19-7-1-00-00-00*/
	Sys_data_object.P1.report_period_start[0]=0x00; //0x00,//report_period_start[0]---
	Sys_data_object.P1.report_period_start[1]=0x00; //0x00,//report_period_start[1]---
	Sys_data_object.P1.report_period_start[2]=0x00; //0x00,//report_period_start[2]---ʱ
	Sys_data_object.P1.report_period_start[3]=0x01; //0x01,//report_period_start[3]---
	Sys_data_object.P1.report_period_start[4]=0x07; //0x07,//report_period_start[4]---
	Sys_data_object.P1.report_period_start[5]=0x19; //0x19,//report_period_start[5]---
	/*ϱʱ:29-7-1-00-00-00*/
	Sys_data_object.P1.report_period_end[0]=0x00; //0x00,//report_period_end[0]---
	Sys_data_object.P1.report_period_end[1]=0x00; //0x00,//report_period_end[1]---
	Sys_data_object.P1.report_period_end[2]=0x00; //0x00,//report_period_end[2]---ʱ
	Sys_data_object.P1.report_period_end[3]=0x01; //0x01,//report_period_end[3]---
	Sys_data_object.P1.report_period_end[4]=0x07; //0x07,//report_period_end[4]---
	Sys_data_object.P1.report_period_end[5]=0x99; //0x99,//report_period_end[5]---
	/*ϱСֵ:15*/
	Sys_data_object.P1.report_step_len.datas =15;// 15,//report_step_len.datas_map.data0 //ֵΪ15s
	/*Դ*/
	Sys_data_object.P1.report_retry_times =0; //ĬԴΪ0 
	/*ܼϱʼʱ*/
	Sys_data_object.P1.report_start_time[0] = 0x01; //0x01,//report_start_time[0]---ʼ
	Sys_data_object.P1.report_start_time[1] = 0x07; //0x07,//report_start_time[1]---ʼ
	Sys_data_object.P1.report_start_time[2] = 0x19; //0x19,//report_start_time[2]---ʼ
	Sys_data_object.P1.report_start_time[3] = 0x00; //0x00,//report_start_time[3]---
	Sys_data_object.P1.report_start_time[4] = 0x30; //0x30,//report_start_time[4]---
	Sys_data_object.P1.report_start_time[5] = 0x01; //0x01,//report_start_time[5]---
	/*ܼϱʱ*/
	Sys_data_object.P1.report_start_time[6] = 0x02; //0x02,//report_start_time[6]---ʼɼʱ
	Sys_data_object.P1.report_start_time[7] = 0x07; //0x07,//report_start_time[7]---ʼɼʱ
	Sys_data_object.P1.report_start_time[8] = 0x19; //0x19,//report_start_time[8]---ʼɼʱʱ
	/*ֵ3000L/h=0x00000BB8*/
	Sys_data_object.P1.high_flow_alarm.datas = 3000;
	//0xB8,//high_flow_alarm.datas_map.data0
	//0x0B,//high_flow_alarm.datas_map.data1
	//0x00,//high_flow_alarm.datas_map.data2
	//0x00,//high_flow_alarm.datas_map.data3
	/*ز 6ֽ*/
	Sys_data_object.P1.ies_valve_paras.valve_state = VALVE_STATE_OPEN;//״̬
	Sys_data_object.P1.ies_valve_paras.valve_err = 0;                 //Ƿ쳣
	Sys_data_object.P1.ies_valve_paras.valve_total_time = 20;          //ʱ
	Sys_data_object.P1.ies_valve_paras.valve_AD = VALVE_HOGH_ADC_VALUE;//ADĬֵ
	Sys_data_object.P1.ies_pulse_emergency.datas = 5;	//Ӧˮ 5
	/*ͨƵ:850=0x352*/
	Sys_data_object.P1.report_fre.datas =850; //0x52,//report_fre.datas_map.data0
	//0x03,//report_fre.datas_map.data1
	/*APN20ֽ:ctnb*/	
	Sys_data_object.P1.apn[0] = 0x01; //APNʹ
	Sys_data_object.P1.apn[1] = 0x04; //0x05,//apn[1]APN
	Sys_data_object.P1.apn[2] = 'c';
	Sys_data_object.P1.apn[3] = 't';
	Sys_data_object.P1.apn[4] = 'n';
	Sys_data_object.P1.apn[5] = 'b';
	/*ͨԿ---16ֽ:QINGDAOJICHE-GNB*/
	Sys_data_object.P1.key[0] = 81;								
	Sys_data_object.P1.key[1] = 73;
	Sys_data_object.P1.key[2] = 78;
	Sys_data_object.P1.key[3] = 71;
	Sys_data_object.P1.key[4] = 68;
	Sys_data_object.P1.key[5] = 65;
	Sys_data_object.P1.key[6] = 79;
	Sys_data_object.P1.key[7] = 74;
	Sys_data_object.P1.key[8] = 73;
	Sys_data_object.P1.key[9] = 67;
	Sys_data_object.P1.key[10] = 72;
	Sys_data_object.P1.key[11] = 45;
	Sys_data_object.P1.key[12] = 78;
	Sys_data_object.P1.key[13] = 71;
	Sys_data_object.P1.key[14] = 78;
	Sys_data_object.P1.key[15] = 66;
	/*ַ---7ֽ*/
	Sys_data_object.P1.mac_addr[0] = 0;
	Sys_data_object.P1.mac_addr[1] = 0;
	Sys_data_object.P1.mac_addr[2] = 0;
	Sys_data_object.P1.mac_addr[3] = 0;
	Sys_data_object.P1.mac_addr[4] = 0;
	Sys_data_object.P1.mac_addr[5] = 0;
	Sys_data_object.P1.mac_addr[6] = 0;
	/*к---7ֽ*/
	Sys_data_object.P1.ser_num[0] =0;
	Sys_data_object.P1.ser_num[1] =0;
	Sys_data_object.P1.ser_num[2] =0;
	Sys_data_object.P1.ser_num[3] =0;
	Sys_data_object.P1.ser_num[4] =0;
	Sys_data_object.P1.ser_num[5] =0;
	Sys_data_object.P1.ser_num[6] =0;
	/*ͨŵַ---7ֽ*/
	Sys_data_object.P1.met_addr[0] =0x01;
	Sys_data_object.P1.met_addr[1] =0;
	Sys_data_object.P1.met_addr[2] =0;
	Sys_data_object.P1.met_addr[3] =0;
	Sys_data_object.P1.met_addr[4] =0;
	Sys_data_object.P1.met_addr[5] =0x33;
	Sys_data_object.P1.met_addr[6] =0x78;
	/*ַ̻ʶ---1ֽ*/
	Sys_data_object.P1.solidify_mac_addr_flg = 0x00;
	/*طϱ---5ֽ,*/
	Sys_data_object.P1.ies_valve_up_times.valve_up_times_pre = 4;	//طϱ(4*30)
	Sys_data_object.P1.ies_valve_up_times.valve_up_times_total = 24;
	Sys_data_object.P1.ies_valve_up_times.valve_up_times_realtime = 0;	
	Sys_data_object.P1.ies_valve_up_times.valve_auto_check = VALVE_AUTO_CHECK_OPEN;//VALVE_AUTO_CHECK_CLOSE;//ÿ³ԼǷ=0xAAʾĬϹر
	Sys_data_object.P1.ies_valve_up_times.reserv = 0x00;
	/*ñԿ---1ֽ*/
	Sys_data_object.P1.enable_bak_key = 0x00; 
	/*´ͨѶԿnum---1ֽ*/
	Sys_data_object.P1.last_key_num = 0x00;
	/*¶ϵ0---4ֽ*/
	Sys_data_object.P1.temperature_coefficient0.datas = 0x00000000;//0x00,0x00,0x00,0x00,//temperature_coefficient0
	/*¶ϵ1---4ֽ*/
	Sys_data_object.P1.temperature_coefficient1.datas = 0x00000000;//0x00,0x00,0x00,0x00,//temperature_coefficient1
	/*Сϵ---4ֽ*/
	Sys_data_object.P1.flow_coefficient_small.datas = 0x00010000;//0x00,0x00,0x01,0x00,//flow_coefficient_small   0x00010000
	/*ϵ0---4ֽ*/
	Sys_data_object.P1.flow_coefficient_middle0.datas = 0x00010000;//0x00,0x00,0x01,0x00,//flow_coefficient_middle0 0x00010000
	/*ϵ1---4ֽ*/
	Sys_data_object.P1.flow_coefficient_middle1.datas = 0x00010000;//0x00,0x00,0x01,0x00,//flow_coefficient_middle1 0x00010000
	/*ϵ2---4ֽ*/
	Sys_data_object.P1.flow_coefficient_middle2.datas = 0x00010000;//0x00,0x00,0x01,0x00,//flow_coefficient_middle2 0x00010000
	/*ϵ3---4ֽ*/
	Sys_data_object.P1.flow_coefficient_middle3.datas = 0x00010000;//0x00,0x00,0x01,0x00,//flow_coefficient_middle3 0x00010000  
	/*ϵ---4ֽ*/
	Sys_data_object.P1.flow_coefficient_large.datas = 0x00010000;//0x00,0x00,0x01,0x00,//flow_coefficient_large   0x00010000
	/*ü춨---1ֽ*/
	Sys_data_object.P1.enable_verification_function =0x5A;// 0x5A,//enable_verification_function 
	/*ú⹦---1ֽ*/
	Sys_data_object.P1.enable_infrared_function = 0x5A;// 0x5A,//enable_infrared_function
	/*---32ֽ*/
	for(int i=0;i<32;i++)
	{
		Sys_data_object.P1.func_cfg_bytes[i] = 0x00;
	}
	Sys_data_object.P1.func_cfg_bytes[0]=15;//func_cfg_bytes[0]---ʱ,Ĭ15
	//0x00,//func_cfg_bytes[1]---ⰴֵ:0x10=16 ---ɾ
	//0x00,//func_cfg_bytes[2]ԶԹĬϹر,(0xAA)
	//0x00,//func_cfg_bytes[3]ĬϹر(0xAA)
	////func_cfg_bytes[4~5]ԭ-عADCĬֵ 
	//0x00,//[6]ԭ---طϱ
    //0x00,//[7]0x55Ҫ,Ĭϲ
	Sys_data_object.P1.func_cfg_bytes[8]=0xAA,//[8]֡ϱ־(0xAAΪ֡)
	//Sys_data_object.P1.func_cfg_bytes[9]=0xAA,//[9]0XAA²Լ
	Sys_data_object.P1.func_cfg_bytes[10]=0x55;//[10]0x55ACKжϱɹ
	//Sys_data_object.P1.func_cfg_bytes[11]=0x55;//[11]0x55,MN316ͷ书
	//Sys_data_object.P1.func_cfg_bytes[12]=0x80,//[12]ʹPSMģʽϱ,0x80طʹPSM,0x82һֱʹPSM
	Sys_data_object.P1.func_cfg_bytes[13]=0x11;//ʣӦϱƵ1
	Sys_data_object.P1.func_cfg_bytes[14]=0x23;//ʣӦϱƵ2
	Sys_data_object.P1.func_cfg_bytes[15]=0x7F;//ʣӦϱƵ3 	//func_cfg_bytes[15]---ԭ---ʱĬϿ
	Sys_data_object.P1.func_cfg_bytes[16]=2;//[16]:㲥2s,λ,
	Sys_data_object.P1.func_cfg_bytes[17]=50;//[17]:Ӽ50ms,λms
	Sys_data_object.P1.func_cfg_bytes[18]=0x00;//[18]:书,0:2.5dbm;1:0dbm;2:-5dbm;3:-10dbm
	Sys_data_object.P1.func_cfg_bytes[19]=5;//[19]:ɨ5
	Sys_data_object.P1.func_cfg_bytes[20]=5;//ӦˮĬ5
	Sys_data_object.P1.func_cfg_bytes[21]=0;//Թ,Ĭ0ر
	Sys_data_object.P1.func_cfg_bytes[22]=7;//λ,Ĭ7
	Sys_data_object.P1.func_cfg_bytes[23]=20;//ÿλ,Ĭ20
	/*ʹ---2ֽ:Ĭ600ps=0x0258*/
	//(DEFAULT_START_FLOW&0xFF),((DEFAULT_START_FLOW>>8)&0xFF), //#define   DEFAULT_START_FLOW   0x00D1 //DN20ͭ63KPAʱʹֵ   
	Sys_data_object.P1.start_flow.datas = DEFAULT_START_FLOW;
	/*ʽ---2ֽ:ĬϷʽ1*/
	Sys_data_object.P1.counter_current_flow.datas = 0x2B1A;//0x1A,0x2B,
	/*Ƶ---1ֽ:Ĭ8*/
	Sys_data_object.P1.sampling_frequency = 0x08;// 0x08,
	/*С---1ֽ:Ĭ16*/
	Sys_data_object.P1.buf_length = 0x10;// 0x10,
	/*Ĭܼ洢0:30s*/
	Sys_data_object.P1.storage_frequency = 15;//ΪĬ15Ӵ洢
	/*ĬͲƵ4(8Hz),߲Ƶ5(16Hz)*/
	Sys_data_object.P1.jx_sampling_frequency[0] = 0x04; //0x04,0x05,
	Sys_data_object.P1.jx_sampling_frequency[1] = 0x05;
	/*ĬNBģʽΪϵģʽ*/
	Sys_data_object.P1.jx_psm_pwdown =0x01; //0x01,
	/*ĬNBϱʧܺ4Сʱ,ʱѯcereg 40*/
	//0x40,0x38,60,0x00
	#if PRODUCT_SY
	    /*ԼĬNBϱʧܺ30,ʱѯcereg 60*/
		Sys_data_object.P1.Upload_again_interval_time.datas = 1800;//1800=30x60
	#else
		Sys_data_object.P1.Upload_again_interval_time.datas = 14400;//14400=4x3600
	#endif
	Sys_data_object.P1.nb_para_login_ask_times.datas = 40;//CGATTѯ
	//ز
	Sys_data_object.P1.Supplemental_send_flag.datas = 0;
	Sys_data_object.P1.histroy_r = 0;
	Sys_data_object.P1.histroy_w = 0;
	//
	Sys_data_object.P1.ies_pulse_remain.datas = 0;//ʹӦˮ
	//صز
	//#if UPLOAD_MODE_1
	Sys_data_object.P1.run_information_object.total_use_sum_times_sec.to_uint32 = 0;//ƹʱ
	Sys_data_object.P1.run_information_object.bat_surplus.to_uint32 = ENERGY_OF_26500;//صuAH
	Sys_data_object.P1.run_information_object.use_sum_times_sec.to_uint32 = 0;//ۼƹʱ
	Sys_data_object.P1.run_information_object.nb_use_sum_times_sec.to_uint32 = 0;//nbۼƹʱ
	Sys_data_object.P1.run_information_object.nb_upload_happen_num = 0;//nb
	Sys_data_object.P1.run_information_object.valve_use_sum_times_sec = 0;//Źʱ
	Sys_data_object.P1.run_information_object.ee_remain_para_energy_life = 3;//ֵ
	//#endif
	//
	Sys_data_object.P3.function_switch.ble_adv_fre = Sys_data_object.P1.func_cfg_bytes[16];//㲥2
	Sys_data_object.P3.function_switch.ble_con_para = Sys_data_object.P1.func_cfg_bytes[17];//Ӽ50ms
	Sys_data_object.P3.function_switch.ble_tx_power = Sys_data_object.P1.func_cfg_bytes[18];//书
	Sys_data_object.P3.function_switch.ble_scan_times = Sys_data_object.P1.func_cfg_bytes[19];//ɨ
	Sys_data_object.P1.ies_pulse_emergency.datas =  Sys_data_object.P1.func_cfg_bytes[20];//Ӧˮ
	Sys_data_object.P3.function_switch.password_enable = Sys_data_object.P1.func_cfg_bytes[21];//ʹ
}

//EEжҪ
void set_important_data_rd_state (void)
{
    important_data_rd_state = IMPORTANT_DATA_OP_S1;
}
u8 get_important_data_rd_state (void)
{
    return important_data_rd_state;
}
void LoadEepromImportantData(void)
{
    set_important_data_rd_state();
    while(get_important_data_rd_state())
    {
        EeReadImportantDataMachine();
        EepMachineDriver();
    }
	Meter_BootVersionInit();//ȡboot汾
	Sys_data_object.P3.NBSleepMode = 0;//PSMģʽϱ
}
//ȡҪ
void EeReadImportantDataMachine(void)
{
    switch(important_data_rd_state)
    {
        case IMPORTANT_DATA_OP_S0:
		{
		}
        break;

        case IMPORTANT_DATA_OP_S1:
        {
			task_init_complete = FALSE;
			tmp_init_stat = EE_INIT_STATE_S1;
			important_data_rd_state=IMPORTANT_DATA_OP_S2;
        }
        break;

        case IMPORTANT_DATA_OP_S2://ϵͳʼ
        {
            SysData_Init();
			if(task_init_complete == TRUE)
			{
				task_init_complete = FALSE;
				tmp_init_stat = EE_INIT_STATE_S1;
				important_data_rd_state=IMPORTANT_DATA_OP_S3;
			}
        }
        break;
		
		case IMPORTANT_DATA_OP_S3://ʽϵʼ
		{
			Coefficient_Init();
			if(task_init_complete == TRUE)
			{
				task_init_complete = FALSE;
				tmp_init_stat = EE_INIT_STATE_S1;
				important_data_rd_state=IMPORTANT_DATA_OP_S4;
			}
		}
		break;
		
		case IMPORTANT_DATA_OP_S4://ϵʼ
		{
			Flow_coef_Init();
			if(task_init_complete == TRUE)
			{
				task_init_complete = FALSE;
				tmp_init_stat = EE_INIT_STATE_S1;
				important_data_rd_state=IMPORTANT_DATA_OP_S5;
			}
		}
		break;
		
		case IMPORTANT_DATA_OP_S5://UDP ipʼ
		{
			UDP_Update_Init();
			if(task_init_complete == TRUE)
			{
				task_init_complete = FALSE;
				tmp_init_stat = EE_INIT_STATE_S1;
				important_data_rd_state=IMPORTANT_DATA_OP_S6;
			}
		}
		break;
		case IMPORTANT_DATA_OP_S6://SOEָʼ
		{
			SOE_Pint_Init();
			if(task_init_complete == TRUE)
			{
				task_init_complete = FALSE;
				tmp_init_stat = EE_INIT_STATE_S1;
				important_data_rd_state=IMPORTANT_DATA_OP_S7;
			}
		}
		break;
		
		case IMPORTANT_DATA_OP_S7://RTCCʼ
		{
			RtccInitApp();
			if(task_init_complete == TRUE)
			{
				task_init_complete = FALSE;
				tmp_init_stat = EE_INIT_STATE_S1;
				important_data_rd_state=IMPORTANT_DATA_OP_S8;
			}
		}
		break;
		
		case IMPORTANT_DATA_OP_S8://,ٱһϵ־
		{
			if(TASK_IDLE == EepIfIdle())
			{
				if(FRAME_FIRST_POWER_FLG != Sys_data_object.P1.first_power_flg)//ǵһϵ
				{
					Sys_data_object.P1.first_power_flg = FRAME_FIRST_POWER_FLG;//һϵ־
					EepWrite(&Sys_data_object.P1.first_power_flg, EEP_FRAME_BASE_ADDR, 1, &important_data_rd_msg);
				}
				important_data_rd_state = IMPORTANT_DATA_OP_S9;
			}
		}
		break;

		case IMPORTANT_DATA_OP_S9:
		{
			if(TASK_IDLE == EepIfIdle())
			{
                important_data_rd_state = IMPORTANT_DATA_OP_S0;			
			}
		}
		break;

        default:
        {
            important_data_rd_state = IMPORTANT_DATA_OP_S0;
        }
        break;
    }
}
//״̬Ƿ
u8 EeReadImportantDataIfIdle(void)
{
    if(TASK_IDLE == EepIfIdle())
    {
        if(IMPORTANT_DATA_OP_S0 == important_data_rd_state)
        {
            return TASK_IDLE;
        }
        else
        {
            return TASK_BUSY;
        }
    }
    else
    {
        return TASK_BUSY;
    }
}
void StartEeReadImportantData(void)
{
    important_data_rd_state = IMPORTANT_DATA_OP_S1;
}
/*******************************************************************************
 * @fun_name:	SysData_Init
 * @brief   :   ϵͳʼ
 * @param[in] :	None
 * @param[out]: None
 * @retval    : None
 * @other     :
 ******************************************************************************/
static void SysData_Init(void)
{
	switch (tmp_init_stat)
	{
		case EE_INIT_STATE_S0:
		{
			break;
		}
		case EE_INIT_STATE_S1://ȡһϵ־
		{
			if (TASK_IDLE == EepIfIdle())
			{
				EepRead(EEP_FRAME_FIRST_POWER_ADDR, &Sys_data_object.P1.first_power_flg, sizeof(Sys_data_object.P1), &important_data_rd_msg);
				tmp_init_stat = EE_INIT_STATE_S2;
			}
			break;
		}
		case EE_INIT_STATE_S2://жǷһϵ
		{
			if (TASK_IDLE == EepIfIdle())
			{
				if(FRAME_FIRST_POWER_FLG != Sys_data_object.P1.first_power_flg)//ǵһϵ,ʼɹٱһϵ־
				{
					Sys_data_object.P3.FirstPowerOnFlag = FIRST_POWER_ON_FLAG;
					FirstPowerOnInit();
					EepWrite(&(Sys_data_object.P1.start_using_flg), (EEP_FRAME_FIRST_POWER_ADDR+1), (sizeof(Sys_data_object.P1)-1), &important_data_rd_msg);
				}
				else
				{
					Sys_data_object.P3.FirstPowerOnFlag = 0;
				}
				Sys_data_object.P3.ProductUpoadFailFlag =0;
				tmp_init_stat = EE_INIT_STATE_S3;
			}
			break;
		}
		case EE_INIT_STATE_S3://ҪϷж:־
		{
			if (TASK_IDLE == EepIfIdle())
			{
				if((0x2B1A !=Sys_data_object.P1.counter_current_flow.datas) &&(0x4D3C !=Sys_data_object.P1.counter_current_flow.datas))
				{
					Sys_data_object.P1.counter_current_flow.datas = 0x2B1A;
					EepWrite(&Sys_data_object.P1.counter_current_flow.datas_map.data0,EEP_FRAME_COUNTER_CURRENT_FLOW_ADDR, sizeof (Sys_data_object.P1.counter_current_flow.datas), &important_data_rd_msg);
				}
				tmp_init_stat = EE_INIT_STATE_S4;
			}
			break;
		}
		case EE_INIT_STATE_S4://ҪϷж:ʼ
		{
			if (TASK_IDLE == EepIfIdle())
			{
				if((Sys_data_object.P1.start_flow.datas < MIN_START_FLOW)||(Sys_data_object.P1.start_flow.datas > MAX_START_FLOW))  
                {
                    Sys_data_object.P1.start_flow.datas = DEFAULT_START_FLOW;//Ĭֵ
                    EepWrite(&Sys_data_object.P1.start_flow.datas_map.data0, EEP_FRAME_START_FLOW_ADDR, 2, &important_data_rd_msg);
                }
				tmp_init_stat = EE_INIT_STATE_S5;
			}
			break;
		}
		case EE_INIT_STATE_S5:
		{
			if (TASK_IDLE == EepIfIdle())
			{
				Frame_Para_Init();//ϵͳʼ 
				task_init_complete = TRUE;
				tmp_init_stat = EE_INIT_STATE_S0;
			}
			break;
		}
		default:
		{
			tmp_init_stat = EE_INIT_STATE_S0;
			break;
		}
	}
}
/*******************************************************************************
 * @fun_name:	Coefficient_Init
 * @brief   :   ʽϵϵʼ
 * @param[in] :	None
 * @param[out]: None
 * @retval    : None
 * @other     :
 ******************************************************************************/
static void Coefficient_Init(void)
{
      switch (tmp_init_stat)
      {
        case EE_INIT_STATE_S0:
        {
        }
		break;
		case EE_INIT_STATE_S1:
        {
			if (TASK_IDLE == EepIfIdle())
			{
				if(FRAME_FIRST_POWER_FLG != Sys_data_object.P1.first_power_flg)//ǵһϵ
				{
					memcpy(&cal_coefficient[0].flt, default_coefficient,sizeof(default_coefficient));//ʽģϵʼ
					EepWrite(&cal_coefficient[0].value[0], FRAME_FLOW_COEFFICIENT_ADDR, sizeof (cal_coefficient), &important_data_rd_msg);
					tmp_init_stat = EE_INIT_STATE_S3;
				}
				else//ǵһϵ
				{
					EepRead(FRAME_FLOW_COEFFICIENT_ADDR, &cal_coefficient[0].value[0], sizeof (cal_coefficient), &important_data_rd_msg);
					tmp_init_stat = EE_INIT_STATE_S20;
				}
			} 
        } 
		break;
		case EE_INIT_STATE_S20:
		{
			if (TASK_IDLE == EepIfIdle())
			{
				u8 flow_coef_ok_flg = 0; //ʽϵ쳣flag
				for(u8 i=0;i<MULT_COEFFICIENT_BUF_NUM;i++)//жϵϷԣϷĬ
				{
					if(0xFFFFFFFF==cal_coefficient[i].value_u32)//ϵĬΪ0xFFFFFFFF쳣
					{
						flow_coef_ok_flg=0;							
						break;
					}
					if((COEFFICIENT_MAX < cal_coefficient[i].flt)||(cal_coefficient[i].flt <COEFFICIENT_MIN))//жϷΧдȷ-20191112
					{
						flow_coef_ok_flg=0;							
						break;
					}
					else if(cal_coefficient[i].flt != 0)
					{
						flow_coef_ok_flg=1;//ϵһΪ0flag1
					}
				}
				if(0 == flow_coef_ok_flg)//ж쳣ϵ,дĬϵ
				{
					memcpy(&cal_coefficient[0].flt, default_coefficient,sizeof(default_coefficient));
					EepWrite(&cal_coefficient[0].value[0], FRAME_FLOW_COEFFICIENT_ADDR, sizeof (cal_coefficient), &important_data_rd_msg);
				}
				tmp_init_stat = EE_INIT_STATE_S3;
			}                    
		}
		break;
		case EE_INIT_STATE_S3:
        {
            if (TASK_IDLE == EepIfIdle())
            {
				task_init_complete = TRUE;
                tmp_init_stat = EE_INIT_STATE_S0;
            }
		}
		break;
		default:
		{
			tmp_init_stat = EE_INIT_STATE_S0;
		    break;
		}
      }
}
/*******************************************************************************
 * @fun_name:	Flow_coef_Init
 * @brief   :   ϵϵʼ
 * @param[in] :	None
 * @param[out]: None
 * @retval    : None
 * @other     :
 ******************************************************************************/
static void Flow_coef_Init(void)
{
      switch (tmp_init_stat)
      {
        case EE_INIT_STATE_S0:
        {
            break;
        }
		case EE_INIT_STATE_S1://һϵ
        {
			if (TASK_IDLE == EepIfIdle())
			{
				if(FRAME_FIRST_POWER_FLG != Sys_data_object.P1.first_power_flg)//ǵһϵ
				{
					memcpy(&(cal_flow_coefficient[0].datas_map.data0), default_flow_coefficient, sizeof (default_flow_coefficient));//ϵʼ
					EepWrite(&cal_flow_coefficient[0].datas_map.data0, FRAME_FLOW_LOW_COEFFICIENT_ADDR, sizeof (cal_flow_coefficient), &important_data_rd_msg);
					tmp_init_stat = EE_INIT_STATE_S3;
				}
				else//ǵһϵ
				{
					EepRead(FRAME_FLOW_LOW_COEFFICIENT_ADDR, &cal_flow_coefficient[0].datas_map.data0, sizeof (default_flow_coefficient), &important_data_rd_msg);
					tmp_init_stat = EE_INIT_STATE_S20;
				}
			}
            break;
        }
        case EE_INIT_STATE_S20:
        {
            if (TASK_IDLE == EepIfIdle())
            {
                u8 flow_coef_ok_flg = 1;//ϵ쳣־  1Ϊ   0쳣Ϊ

                for(u8 i=0;i<FLOW_COEFFICIENT_BUF_NUM;i++)//18ϵ
                {
                    if(0xFFFFFFFF==cal_flow_coefficient[i].datas)//ϵĬΪ0xFFFFFFFF쳣
                    {
                        flow_coef_ok_flg=0;							
                        break;
                    }
                    if((FLOW_COEFFICIENT_MAX < cal_flow_coefficient[i].datas)||(cal_flow_coefficient[i].datas <FLOW_COEFFICIENT_MIN))//жϷΧдȷ-20191112
                    {
                        flow_coef_ok_flg=0;							
                        break;
                    }
                }
                if(0 == flow_coef_ok_flg)//жϵ쳣 쳣˾ͽĬϵд뵽EEPROM
                {
                    memcpy(&(cal_flow_coefficient[0].datas_map.data0), default_flow_coefficient, sizeof (default_flow_coefficient));//ϵʼ
					EepWrite(&cal_flow_coefficient[0].datas_map.data0, FRAME_FLOW_LOW_COEFFICIENT_ADDR, sizeof (cal_flow_coefficient), &important_data_rd_msg);
                } 
				tmp_init_stat = EE_INIT_STATE_S3;					
            }                    
            break;
        }
		case EE_INIT_STATE_S3:
        {
            if (TASK_IDLE == EepIfIdle())
            {
				task_init_complete = TRUE;
                tmp_init_stat = EE_INIT_STATE_S0;
            }
			break;
		}
		default:
		{
			tmp_init_stat = EE_INIT_STATE_S0;
		    break;
		}		
     }
}
/*******************************************************************************
 * @fun_name:	UDP_Update_Init
 * @brief   :   UDPϵʼ
 * @param[in] :	None
 * @param[out]: None
 * @retval    : None
 * @other     :
 ******************************************************************************/
static void UDP_Update_Init(void)
{
	switch (tmp_init_stat)
	{
		case EE_INIT_STATE_S0:
		{
			break;
		}
		case EE_INIT_STATE_S1:
		{
			if (TASK_IDLE == EepIfIdle())
			{
				if(FRAME_FIRST_POWER_FLG != Sys_data_object.P1.first_power_flg)//ǵһϵ
				{
					#if PRODUCT_SY
					Sys_data_object.P2.server_ip[0] = 223;
					Sys_data_object.P2.server_ip[1] = 100;
					Sys_data_object.P2.server_ip[2] = 22;
					Sys_data_object.P2.server_ip[3] = 125;
					Sys_data_object.P2.server_port.datas = 3031;
					#else
					Sys_data_object.P2.server_ip[0] = 60;
					Sys_data_object.P2.server_ip[1] = 208;
					Sys_data_object.P2.server_ip[2] = 16;
					Sys_data_object.P2.server_ip[3] = 58;
					Sys_data_object.P2.server_port.datas = 7833;
					#endif
					EepWrite(&Sys_data_object.P2.server_ip[0], EEP_UPDATE_UDP_IP, 6, &important_data_rd_msg);
					tmp_init_stat = EE_INIT_STATE_S3;
				}
				else//ǵһϵ
				{
					EepRead(EEP_UPDATE_UDP_IP, &Sys_data_object.P2.server_ip[0], 6, &important_data_rd_msg);
					tmp_init_stat = EE_INIT_STATE_S3;
				}
			}
			break;			
		}
		case EE_INIT_STATE_S3:
		{
			if (TASK_IDLE == EepIfIdle())
			{
				task_init_complete = TRUE;
				tmp_init_stat = EE_INIT_STATE_S0;				
			}
			break;
		}
		default:
		{
			tmp_init_stat = EE_INIT_STATE_S0;
			break;
		}
	}
}
/*******************************************************************************
 * @fun_name:	SOE_Pint_Init
 * @brief   :   SOE洢ָϵʼ
 * @param[in] :	None
 * @param[out]: None
 * @retval    : None
 * @other     :
 ******************************************************************************/
static void SOE_Pint_Init(void)
{
	switch (tmp_init_stat)
	{
		case EE_INIT_STATE_S0:
		{
			break;
		}
		case EE_INIT_STATE_S1:
		{
			if (TASK_IDLE == EepIfIdle())
			{
				if(FRAME_FIRST_POWER_FLG != Sys_data_object.P1.first_power_flg)//ǵһϵ
				{
					Sys_data_object.P4.Point_SOE_write = 0;
					EepWrite(&Sys_data_object.P4.Point_SOE_write, EEP_ADDR_SOE_WR_POINT, 1, &important_data_rd_msg);
					tmp_init_stat = EE_INIT_STATE_S3;
				}
				else//ǵһϵ
				{
					EepRead(EEP_ADDR_SOE_WR_POINT, &Sys_data_object.P4.Point_SOE_write, 1, &important_data_rd_msg);
					tmp_init_stat = EE_INIT_STATE_S3;
				}
			}
			break;			
		}
		case EE_INIT_STATE_S3:
		{
			if (TASK_IDLE == EepIfIdle())
			{
				task_init_complete = TRUE;
				tmp_init_stat = EE_INIT_STATE_S0;				
			}
			break;
		}
		default:
		{
			tmp_init_stat = EE_INIT_STATE_S0;
			break;
		}
	}
}
static void RtccInitApp(void)
{
	switch (tmp_init_stat)
	{
		case EE_INIT_STATE_S0:
		{
			break;
		}
		case EE_INIT_STATE_S1:
		{
			if (TASK_IDLE == EepIfIdle())
			{
				EepRead(EE_FIRST_USE_ADDR, Sys_data_object.ee_data.byte, sizeof (RTCC_EE_DATA), &important_data_rd_msg); //EE
				tmp_init_stat = EE_INIT_STATE_S2;
			}
			break;			
		}
		case EE_INIT_STATE_S2:
		{
			if (TASK_IDLE == EepIfIdle())
			{
				 if (Sys_data_object.ee_data.data.first_flag != RTCC_FIRST_FLAG)
                    {
                        //һϵ
                        if (EepIfIdle())
                        {
                            Sys_data_object.ee_data.data.first_flag = RTCC_FIRST_FLAG; //дϵ־λ
                            Sys_data_object.ee_data.data.work_hour = 0; //ۼƹʱ
                            Sys_data_object.ee_data.data.day_data = 0xFFFFFFFF; //ۼֵ
                            RtccGetDateTime(&Sys_data_object.ee_data.data.start_time_up); //¼Ƴʱ
                            EepWrite(Sys_data_object.ee_data.byte, EE_FIRST_USE_ADDR, sizeof (RTCC_EE_DATA), &important_data_rd_msg);
                            tmp_init_stat = EE_INIT_STATE_S3;
                        }
                    }
                    else
                    {							
                        //ʱRTCCǷܷ
						DateTime init_time;
                        if (ERROR == RtccGetDateTime(&init_time)) //ϵʱ䲻Ϸ
                        {
                            init_time.s.year = 0x22;
                            init_time.s.month = 0x01;
                            init_time.s.day = 0x01;
                            init_time.s.hour = 0x00;
                            init_time.s.minute = 0x00;
                            init_time.s.second = 0x00;
                            RtccSetDateTime(&init_time);
                        }
						task_init_complete = TRUE;
						tmp_init_stat = EE_INIT_STATE_S0;
                    }
				
			}
			break;
		}
		case EE_INIT_STATE_S3:
		{
			if (TASK_IDLE == EepIfIdle())
			{
				task_init_complete = TRUE;
				tmp_init_stat = EE_INIT_STATE_S0;				
			}
			break;
		}
		default:
		{
			tmp_init_stat = EE_INIT_STATE_S0;
			break;
		}
	}
}
/*******************************************************************************
 * @fun_name:	Frame_Para_Init
 * @brief   :   ϵͳǰˢ
 * @param[in] :
 * @param[out]: u32
 * @retval    : None
 * @other     :
 ******************************************************************************/
void Frame_Para_Init(void)
{
	MET_STATE temp_state; //״̬
	frame_para_buf[FramePara_DNx] = GP30_APP_DNX;//DNx
	frame_para_buf[FramePara_Tc0] = Sys_data_object.P1.temperature_coefficient0.datas;
	frame_para_buf[FramePara_Tc1] = Sys_data_object.P1.temperature_coefficient1.datas;
	frame_para_buf[FramePara_FcSmall] = Sys_data_object.P1.flow_coefficient_small.datas;
	frame_para_buf[FramePara_FcMiddle0] = Sys_data_object.P1.flow_coefficient_middle0.datas;
	frame_para_buf[FramePara_FcMiddle1] = Sys_data_object.P1.flow_coefficient_middle1.datas;
	frame_para_buf[FramePara_FcMiddle2] = Sys_data_object.P1.flow_coefficient_middle2.datas;
	frame_para_buf[FramePara_FcLarge] = Sys_data_object.P1.flow_coefficient_large.datas;
	frame_para_buf[FramePara_ReportStartDMY] = Sys_data_object.P1.report_start_time[0]|(Sys_data_object.P1.report_start_time[1]<<8)|(Sys_data_object.P1.report_start_time[2]<<16);
	frame_para_buf[FramePara_ReportStartSMH] = Sys_data_object.P1.report_start_time[8]|(Sys_data_object.P1.report_start_time[7]<<8)|(Sys_data_object.P1.report_start_time[6]<<16);
	frame_para_buf[FramePara_ProgVersion] = PROGRAME_VERSION;
	frame_para_buf[FramePara_MetAddr0_3] = Sys_data_object.P1.met_addr[0]|(Sys_data_object.P1.met_addr[1]<<8)|(Sys_data_object.P1.met_addr[2]<<16)|(Sys_data_object.P1.met_addr[3]<<24);
	frame_para_buf[FramePara_MetAddr4] = Sys_data_object.P1.met_addr[4]|(Sys_data_object.P1.met_addr[5]<<8)|(Sys_data_object.P1.met_addr[6]<<16);
	frame_para_buf[FramePara_FuncCfg0_3] =  Sys_data_object.P1.func_cfg_bytes[0]|(Sys_data_object.P1.func_cfg_bytes[1]<<8)|(Sys_data_object.P1.func_cfg_bytes[2]<<16)|(Sys_data_object.P1.func_cfg_bytes[3]<<24);
	frame_para_buf[FramePara_FuncCfg4_7] =  Sys_data_object.P1.func_cfg_bytes[4]|(Sys_data_object.P1.func_cfg_bytes[5]<<8)|(Sys_data_object.P1.func_cfg_bytes[6]<<16)|(Sys_data_object.P1.func_cfg_bytes[7]<<24);
	frame_para_buf[FramePara_FuncCfg8_11] = Sys_data_object.P1.func_cfg_bytes[8]|(Sys_data_object.P1.func_cfg_bytes[9]<<8)|(Sys_data_object.P1.func_cfg_bytes[10]<<16)|(Sys_data_object.P1.func_cfg_bytes[11]<<24);
	frame_para_buf[FramePara_FuncCfg12_15]= Sys_data_object.P1.func_cfg_bytes[12]|(Sys_data_object.P1.func_cfg_bytes[13]<<8)|(Sys_data_object.P1.func_cfg_bytes[14]<<16)|(Sys_data_object.P1.func_cfg_bytes[15]<<24);
	frame_para_buf[FramePara_ReportEndSMH] = Sys_data_object.P1.report_start_time[3]|(Sys_data_object.P1.report_start_time[4]<<8)|(Sys_data_object.P1.report_start_time[5]<<16);
	frame_para_buf[FramePara_FcMiddle3] = Sys_data_object.P1.flow_coefficient_middle3.datas;
	temp_state = FrameGetByte();
	frame_para_buf[FramePara_Sta1_2] = temp_state.stat1|(temp_state.stat2<<8);//-------------------------------------------------------------
	frame_para_buf[FramePara_CCFlow] = Sys_data_object.P1.counter_current_flow.datas_map.data0|(Sys_data_object.P1.counter_current_flow.datas_map.data1<<8);
	frame_para_buf[FramePara_StartFlow] = Sys_data_object.P1.start_flow.datas;
	/********************/
	frame_para_buf[FramePara_GP30Freq] = Sys_data_object.P1.sampling_frequency;//----------------------------------------------------------------------
	frame_para_buf[FramePara_GP30BufLen] = Sys_data_object.P1.buf_length;//----------------------------------------------------------------------------
	frame_para_buf[FramePara_ReportFreq] = Sys_data_object.P1.Time_upload_2006.buf[0]|(Sys_data_object.P1.Time_upload_2006.buf[1]<<8)|(Sys_data_object.P1.Time_upload_2006.buf[2]<<16)|(Sys_data_object.P1.Time_upload_2006.buf[3]<<24);
    frame_para_buf[FramePara_EnableTestFunc] = Sys_data_object.P1.enable_verification_function;
	frame_para_buf[FramePara_EnableInfrareFunc] = Sys_data_object.P1.enable_infrared_function;
	frame_para_buf[FramePara_StartUsingFunc] = Sys_data_object.P1.start_using_flg;
	frame_para_buf[FramePara_StoreFrequency] = Sys_data_object.P1.storage_frequency;
	frame_para_buf[FramePara_NbParaRetryDelay] = Sys_data_object.P1.Upload_again_interval_time.datas;
	frame_para_buf[FramePara_NbParaLoginAckTimes] = Sys_data_object.P1.nb_para_login_ask_times.datas;
	frame_para_buf[FramePara_BootVersion] = Meter_GetBootVersion();
	//
	Sys_data_object.P3.function_switch.ble_adv_fre = Sys_data_object.P1.func_cfg_bytes[16];//㲥3
	Sys_data_object.P3.function_switch.ble_con_para = Sys_data_object.P1.func_cfg_bytes[17];//Ӽ50ms
	Sys_data_object.P3.function_switch.ble_tx_power = Sys_data_object.P1.func_cfg_bytes[18];//书
	Sys_data_object.P3.function_switch.ble_scan_times = Sys_data_object.P1.func_cfg_bytes[19];//ɨ
	Sys_data_object.P1.ies_pulse_emergency.datas =  Sys_data_object.P1.func_cfg_bytes[20];//Ӧˮ
	Sys_data_object.P3.function_switch.password_enable = Sys_data_object.P1.func_cfg_bytes[21];//ʹ
}
/*******************************************************************************
 * @fun_name:	FrameCheckParaApp
 * @brief   :   ѯϵͳǰ
 * @param[in] :	parameter Frame_CheckParaTypeDefʽö
 * @param[out]: u32
 * @retval    : None
 * @other     :
 ******************************************************************************/
u32 FrameCheckParaApp(Frame_CheckParaTypeDef parameter)
{
    return frame_para_buf[parameter];
}

void EeSysMachine(void)
{
    EeReadImportantDataMachine();
    EepMachineDriver();
}

#ifdef __cplusplus
}
#endif		//#ifdef __cplusplus



